#!/usr/local/bin/perl
#### ȥåХå/ȥӥ塼ץ mktbview.pl V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ

require "libgns.pl";

########################################################################
### BEGIN 
#
{
	$SYSTIME = time;
	( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime( $SYSTIME );

	$argc = $#ARGV+1;
# print "[Cmdline:($argc) @ARGV]\n";
	&Setup();

	if ( $argc < 3 ) {
		die "Required 3 arguments [year month day].";
	}

	$year_today = $ARGV[0]+0;
	$month_today = $ARGV[1]+0;
	$date_today = $ARGV[2]+0;
	$titleno = $ARGV[3]+0;

	if ( $year_today < 1980 ) {
	    die "Arguments: year ($year_today) < 1980.";
	}
	if ( $year_today > 2099 ) {
	    die "Arguments: year ($year_today) > 2099.";
	}
	if ( $month_today < 1 ) {
	    die "Arguments: month ($month_today) < 1.";
	}
	if ( $month_today > 12 ) {
	    die "Arguments: month ($month_today) > 12.";
	}
	if ( $date_today < 1 ) {
	    die "Arguments: day ($date_today) < 1.";
	}
	if ( $date_today > 31 ) {
	    die "Arguments: day ($date_today) > 31.";
	}

	&YMD2DAYS( $year_today, $month_today, $date_today );
	$totaldays_today = $TOTALDAYS;
	&DAYS2YMD( $totaldays_today );
	$year_today = $YEAR + 0;
	$month_today = $MONTH + 0;
	$date_today = $DATE + 0;

	&BindTrackbackView( $year_today, $month_today, $date_today, $titleno );
	&BindTrackbackViewLatest();

	&Finish();
}

########################################################################
### ǥå
#

sub AnalyzeDiaryIndex {
	local( $year, $month ) = @_;
	local( $i, $j, $day, $wday, $part, $topic, $fin, $line, $cmd, $dayntitle, $category, $daytime, $time );
	local( $FIN );

	$NCATEGORYWORD = 0;
	$NTITLE = 0;

	# ʬγפ
	&YMD2DAYS( $year, $month, 1 );
	$wday = $WDAY;
	for ( $day=1; $day<=$DAYS[$month]; $day++, $wday = ($wday+1) % 7 ) {
		$part = 0;
		if ( $day > 10 ) {
			$part++;
		}
		if ( $day > 20 ) {
			$part++;
		}
		$dayntitle = 0;
		$topic = '';
		$category = '';
		$time = '';
		$daytime = '';
		$fin = &MakeMasterFileName( $year, $month, $day );
		$DAYEXIST{$year,$month,$day} = 0;
		next if ( !(-e $fin) ) ;
		$DAYEXIST{$year,$month,$day} = 1;
		$cmd = $NKFCMD . ' -e ' . $fin . "|";
		$FIN = $cmd; open( FIN ) || next;
		while ( $line = <FIN> ) {
			$line =~ s/[\012\015]+//;
			if ( $line =~ s/^\@topic[ \t]+// ) {
				$topic = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@time[ \t]+// ) {
				$time = &Replace( $line, $year, $month, $part, $day );
				if ( $dayntitle > 0 ) {
					$TIME[$dayntitle-1] = $time;
				} else {
					$daytime = $time;
				}
				next;
			}
			if ( $line =~ s/^\@weather[ \t]+// ) {
				$DAYWEATHER[$day] = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@title[ \t]+// ) {
				if ( $dayntitle == 0 ) {
					$dayntitle++;
				}
				$TIME[$dayntitle] = $time;
				$CATEGORY[$dayntitle] = '';
				$TITLE[$dayntitle++] = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@category[ \t]+// ) {
				$category = &Replace( $line, $year, $month, $part, $day );
				if ( $dayntitle > 0 ) {
					$CATEGORY[$dayntitle-1] = $category;
				}
				next;
			}
		}
		close( FIN );
		if ( $dayntitle || $topic ne '' ) {
			$DAYNTITLE[$day] = $dayntitle;
			$DAYTOPIC[$day] = $topic;
			$DAYTOPICTIME[$day] = $daytime;
			$DAYLINK[$day] = sprintf( '%d %d %d %d %d %d', $year, $month, $part, $day, 0, $wday );
			for ( $i=0; $i<$dayntitle; $i++ ) {
				$DAYTITLE{$day,$i} = $TITLE[$i];
				$DAYCATEGORY{$day,$i} = $CATEGORY[$i];
				$DAYTITLETIME{$day,$i} = $TIME[$i];
			}
		}
	}
}

########################################################################
### ȥåХåե֤̾ 
#
sub MakeTrackbackLogFileName {
	local( $year, $month ) = @_;
	local( $s );

	if ( ($year==1) && ($month==1) ) {
		$s = sprintf( "${TBLOGDIR}${SLASH}latesttb.log" );
	} elsif ( ($year==1) && ($month==2) ) {
		$s = sprintf( "${TBLOGDIR}${SLASH}latestcm.log" );
	} else {
		$s = sprintf( "${TBLOGDIR}${SLASH}%04d${SLASH}%02d.log", $year+0, $month+0 );
	}
	return ($s);
}

########################################################################
### ȥåХåȥե֤̾ 
#
sub MakeTrackbackCountLogFileName {
	local( $year, $month ) = @_;
	local( $s );

	$s = sprintf( "${TBLOGDIR}${SLASH}%04d${SLASH}%02dc.log", $year+0, $month+0 );
	return ($s);
}

########################################################################
### HTML󥰻˾㳲Ȥʤʸ
#
sub HTMLCleaning {
	local( $s ) = @_;

	$s =~ s/</&lt;/g;
	$s =~ s/>/&gt;/g;
	return ($s);
}

########################################################################
### ȥåХå/ȥեɤ߹
#
sub GetTrackbackLog {
	local( $year, $month ) = @_;
	local( $s );
	local( $fin );
	local( $umaskback );
	local( $cmd );
	local( $line );
	local( @l );
	local( @expr );
	local( $s );
	local( $n );
	local( $variable, $value );
	local( @param );

	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT_U = ">$TMPDIR/%tbutf8in.txt"; open( FOUT_U );

	$fin = &MakeTrackbackLogFileName( $year, $month );
	open( FIN, $fin );
	while ( $line = <FIN> ) {
		$line =~ s/[\015\012]//g;
		next if ( $line eq "" );
		next if ( $line =~ "^#" );
		undef( %param );
		@l = split( " ", $line );
		@expr = split( '&', $l[1] );
		foreach $s (@expr) {
			( $variable, $value ) = split( '=', $s );
			$value =~ tr/+/ /;
			$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
			$value =~ s/(\x0d|\x0a)+//eg;
			$param{$variable} = $value;
		}
		if (
		  ($param{'title'} ne "" ) &&
		  ($param{'excerpt'} ne "" ) &&
		  ($param{'url'} ne "" ) &&
		  ($param{'blog_name'} ne "" ) 
		) {
			print FOUT_U $l[0] . "\n";
			print FOUT_U $param{'title'} . "\n";
			print FOUT_U $param{'excerpt'} . "\n";
			print FOUT_U $param{'url'} . "\n";
			print FOUT_U $param{'blog_name'} . "\n";
			print FOUT_U $l[3] . " " . $l[4]  . "\n";
		}
		elsif (
		  ($param{'GNSname'} ne "" ) &&
		  ($param{'GNScomment'} ne "" ) 
		) {
			print FOUT_U $l[0] . "\n";
			print FOUT_U $param{'GNSname'} . "\n";
			print FOUT_U $param{'GNScomment'} . "\n";
			print FOUT_U "COMMENT\n";
			print FOUT_U "COMMENT\n";
			print FOUT_U $l[3] . " " . $l[4]  . "\n";
		}
	}

	close( FIN );
	umask( $umaskback );
	close( FOUT_U );
	$cmd = "$NKFCMD --euc $TMPDIR/%tbutf8in.txt>$TMPDIR/%tbeucout.txt";
	system( $cmd );
	$FIN_U = "$TMPDIR/%tbeucout.txt"; open( FIN_U );
	$n = $TB_LOG_N;
	while (!0) {
		$line = <FIN_U>;
		chomp( $line );
		last if ( $line eq "" );
		$TB_LOG_YEAR[$n]     = substr( $line, 0, 4 )+0;
		$TB_LOG_MONTH[$n]    = substr( $line, 4, 2 )+0;
		$TB_LOG_DAY[$n]      = substr( $line, 6, 2 )+0;
		$TB_LOG_TITLENO[$n]  = substr( $line, 8, 2 )+0;
		$line = <FIN_U>;
		chomp( $line );
		$TB_LOG_TITLE[$n]    = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line );
		$TB_LOG_EXCERPT[$n]  = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line );
		$TB_LOG_FROM[$n]     = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line );
		$TB_LOG_BLOGNAME[$n] = &HTMLCleaning( $line );
		$TB_LOG_SORTKEY[$n]  = $TB_LOG_DAY[$n]*1000+$TB_LOG_TITLENO[$n]*10;
		if ( $TB_LOG_FROM[$n] eq "COMMENT" ) {
			$TB_LOG_SORTKEY[$n] += 0;
		} else {
			$TB_LOG_SORTKEY[$n] += 1;
		}
		$line = <FIN_U>;
		chomp( $line );
		$TB_LOG_DATE[$n] = $line;
		$TB_LOG_ORDER[$n]    = $n;
		$n++;
	}
	$TB_LOG_N = $n;
	close( FIN_U );
}

########################################################################
### ȥåХå/ȥȥ񤭹
#
sub PutTrackbackCountLog {
	local( $year, $month ) = @_;
	local( $fout );
	local( $i );
	local( $s );
	local( $umaskback );

	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );

	$fout = &MakeTrackbackCountLogFileName( $year, $month );
	open( FOUT_TBC, ">$fout" );
	foreach $i ( sort (keys %TB_LOG_COUNT) ) {
		$s = $i;
		$s =~ s/\034/,/g;
		print FOUT_TBC "$s $TB_LOG_COUNT{$i}\n";
	}
	close( FOUT_TBC );
	umask( $umaskback );
}

########################################################################
### LatestɽѤSORTKEY
#
sub MakeSortKeyLatest {
	local( $i );

	for ( $i=0; $i<$TB_LOG_N; $i++ ) {
		$TB_LOG_SORTKEY[$i] = $TB_LOG_DATE[$i];
	}
}

########################################################################
### ȥåХåե򥽡Ȥ
#
sub SortTrackbackLog {
	local( $i, $j );
	local( $a );

	for ( $i=1; $i<$TB_LOG_N; $i++ ) {
		for ( $j=$i; $j>=1; $j-- ) {
			if ( $TB_LOG_SORTKEY[$TB_LOG_ORDER[$j]] lt $TB_LOG_SORTKEY[$TB_LOG_ORDER[$j-1]] ) {
				$a = $TB_LOG_ORDER[$j];
				$TB_LOG_ORDER[$j] = $TB_LOG_ORDER[$j-1];
				$TB_LOG_ORDER[$j-1] = $a;
			}
		}
	}
}

########################################################################
### ȥåХåΥǥå
#
sub MakeIndexTrackbackLog {
	local( $i, $j );
	local( $a );
	local( $n );
	local( $year_last, $month_last, $day_last );

	return if ( $TB_LOG_N == 0 );
	$year_last = -1;
	$month_last = -1;
	$day_last = -1;
	
	for ( $i=0; $i<$TB_LOG_N; $i++ ) {
		$n = $TB_LOG_ORDER[$i];
# print "$i $n $TB_LOG_SORTKEY[$n], $TB_LOG_TITLE[$n], $TB_LOG_FROM[$n], $TB_LOG_BLOGNAME[$n], $TB_LOG_EXCERPT[$n], $TB_LOG_DATE[$n]\n";
		if ( ($year_last != $TB_LOG_YEAR[$n]) ||
		     ($month_last != $TB_LOG_MONTH[$n]) ||
		     ($day_last != $TB_LOG_DAY[$n])
		) {
			$year_last = $TB_LOG_YEAR[$n];
			$month_last = $TB_LOG_MONTH[$n];
			$day_last = $TB_LOG_DAY[$n];
			$TB_LOG_INDEX{$year_last,$month_last,$day_last} = $i;
		}
		$TB_LOG_COUNT{$TB_LOG_YEAR[$n],$TB_LOG_MONTH[$n],$TB_LOG_DAY[$n],$TB_LOG_TITLENO[$n]}++;
	}
}

########################################################################
### եɽ 
#
sub PrintTrackbackDate {
	local( $FOUT, $year, $month, $day, $wday, $part ) = @_;
	local( $s );
	local( $tbmode ) = 2;

	$s = sprintf(
	  "<A NAME=\"$ANCHOR%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d\">" .
	  "<SPAN class=\"yymmdd\">%04d/%02d/%02d</SPAN></A> " .
	  "<SPAN class=\"dayweek\">(%s)</SPAN> " .
	  "<SPAN class=\"dayweather\">%s</SPAN> " .
	  "<SPAN class=\"daytopic\">%s</SPAN>" .
	  "",
	  $day, $year, $month, $PARTS[$PART], $day, $year, $month, $day,
	  $WDAYS[$wday], $DAYWEATHER[$day], $DAYTOPIC[$day]
	);

	$s = &SPrintDiaryDate_Config2( $s, $year, $month, $day, $wday, $PART, $DAYWEATHER[$day], $DAYTOPIC[$day], $DAYTOPICTIME[$day], $tbmode );
	$s =~ s/[ ]+$//;
	print $FOUT "<DIV class=\"daybox\">\n";
	print $FOUT "<DIV class=\"datebox\"><H3 class=\"date\">$s</H3></DIV>\n";
}

########################################################################
### ȥ륿ɽ 
#
sub SPrintTrackbackTitle {
	local( $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time ) = @_;
	local( $s );
	local( $catprint );
	local( $tbmode ) = 2;

	if ( $category eq '' ) {
		$s = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A></H4>" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle,
		  $year, $month, $PARTS[$part], $day,
		  $ntitle, $TITLEMARK, $title
		);
	} else {
		$catprint = &MakeCategoryLinkStrings( $year, $category );
		$s = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A>" .
		  "<SPAN class=\"category\"> (%s)</SPAN>" .
		  "</H4>" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle,
		  $year, $month, $PARTS[$part], $day,
		  $ntitle, $TITLEMARK, $title, $catprint
		);
	}

	return ( &SPrintDiaryTitle_Config2( $s, $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time, $tbmode ) );
}

########################################################################
### ȥåХåϤ
#
sub PrintTrackbackLog {
	local( $FOUT, $year, $month, $day ) = @_;
	local( $part, $istoday );
	local( $wday, $i, $s );
	local( $titleno );
	local( $ntitle );
	local( $tbno );
	local( $cmno );

	return if ( !defined($TB_LOG_INDEX{$year,$month,$day}) );

	&YMD2DAYS( $year, $month, $day );
	$wday = $WDAY;
	&GetDiaryPart( $year, $month, $day );
	$part = $PART;

	&PrintTrackbackDate( $FOUT, $year, $month, $day, $wday, $part );

	$ntitle = 0;
	$titleno = -1;
	$tbno = 0;
	$cmno = 0;
	for ( $i=$TB_LOG_INDEX{$year,$month,$day}; $i<$TB_LOG_N; $i++ ) {
		$n = $TB_LOG_ORDER[$i];
		next if ( $TB_LOG_YEAR[$n] != $year );
		next if ( $TB_LOG_MONTH[$n] != $month );
		next if ( $TB_LOG_DAY[$n] != $day );
		if ( $titleno != $TB_LOG_TITLENO[$n] ) {
			$ntitle++;
			if ( $ntitle > 1 ) {
				$s = &SPrintDiaryTitleClose(
				  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
				);
				print $FOUT "$s\n";
			}
			$titleno = $TB_LOG_TITLENO[$n];
			$s = &SPrintTrackbackTitle(
			  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
			);
			print $FOUT "$s\n";
			$tbno = 0;
			$cmno = 0;
		}
		if ( $TB_LOG_FROM[$n] ne "COMMENT" ) {
			$tbno++;
			if ( $tbno == 1 ) {
				$s = sprintf( "<DIV class=\"tbheader\"><B><A NAME=\"%02d%02dtb\" HREF=\"#%02d%02dtb\">[Trackback]</A></B></DIV>\n",
				              $day, $titleno,
				              $day, $titleno
				);
				print $FOUT "$s\n";
			}
			$s = sprintf( "<DL class=\"tbline\"><DT><A NAME=\"%02d%02dtb%d\" HREF=\"#%02d%02dtb%d\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"tbtitle\"><A HREF=\"%s\">%s</A></SPAN></DT>" .
			              "<DD><SPAN class=\"tbexcerpt\">%s</SPAN> " .
			              "<SPAN class=\"tbfrom\">(%s)</SPAN></DD></DL>\n",
			              $day, $titleno, $tbno,
			              $day, $titleno, $tbno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_FROM[$n], $TB_LOG_TITLE[$n], $TB_LOG_EXCERPT[$n],
			              $TB_LOG_BLOGNAME[$n]
			);
			print $FOUT "$s\n";
		} else {
			$cmno++;
			if ( $cmno == 1 ) {
				$s = sprintf( "<DIV class=\"cmheader\"><B><A NAME=\"%02d%02dcm\" HREF=\"#%02d%02dcm\">[Comment]</A></B></DIV>\n",
				              $day, $titleno,
				              $day, $titleno
				);
				print $FOUT "$s\n";
			}
			$s = sprintf( "<DIV class=\"cmline\"><A NAME=\"%02d%02dcm%d\" HREF=\"#%02d%02dcm%d\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"cmcomment\">%s</SPAN> " .
			              "<SPAN class=\"cmname\">(%s)</SPAN></DIV>\n",
			              $day, $titleno, $cmno,
			              $day, $titleno, $cmno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_EXCERPT[$n], $TB_LOG_TITLE[$n]
			);
			print $FOUT "$s\n";
		}
	}

	if ( $ntitle >= 1 ) {
		$s = &SPrintDiaryTitleClose(
		  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
		);
		print $FOUT "$s\n";
	}
	print $FOUT "</DIV><!-- daybox -->\n";

}

########################################################################
### ȥåХåѥӥ塼 
#
sub BindTrackbackView {
	local( $year, $month, $day, $titleno ) = @_;
	local( $enddate, $part, $i, $fout, $fout2, $cmd, $fin, $line, $needinterval );
	local( $umaskback );
	local( $FOUT );

	$needinterval = 0;

	$fout = $TMPDIR . $SLASH . '%tmptb.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $TRACKBACKHEADERNAME, $year, $month, 0 );
	&PrintStart( *FOUT );

	$TB_LOG_N = 0;
	&GetTrackbackLog( $year, $month );
	&SortTrackbackLog();
	&MakeIndexTrackbackLog();
	&AnalyzeDiaryIndex( $year, $month );
	&PutTrackbackCountLog( $year, $month );

	&Setup_DAYS( $year );
	for ( $i=1; $i<=$DAYS[$month]; $i++ ) {
		if ( !defined($TB_LOG_INDEX{$year,$month,$i}) ) {
			if ( !$PRINTNOEXISTDAY ) {
				next;
			}
		}
		if ( $needinterval ) {
			&PrintInterval( *FOUT );
		}
		&PrintTrackbackLog( *FOUT, $year, $month, $i );
		$needinterval = !0;
	}
	&PrintTerminate( *FOUT );
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $TRACKBACKFOOTERNAME, $year, $month, 0 );
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = sprintf( $PUTDIR . $SLASH . '%04d%02d%st.html', $year, $month );
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
	system( $cmd );
	umask( $umaskback );

}

########################################################################
### ȥåХå(latest)ѥӥ塼 
#
sub BindTrackbackViewLatest {
	local( $year, $month, $day, $titleno );
	local( $tb_s, $tb_e, $i, $n, $s, $cm );
	local( $umaskback );
	local( $FOUT );

	$needinterval = 0;

	$fout = $TMPDIR . $SLASH . '%tmptb.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";

	$TB_LOG_N = 0;
	&GetTrackbackLog( 1, 1 );  # latesttb
	&GetTrackbackLog( 1, 2 );  # latestcm
	&MakeSortKeyLatest();
	&SortTrackbackLog();

	$tb_s = $TB_LOG_N-1;
	$tb_e = $tb_s - $VIEWLATESTTRACKBACKCOUNT+1;
	$tb_e = 0 if ( $tb_e < 0 );
	for ( $i=$tb_s; $i>=$tb_e; $i-- ) {
		$n = $TB_LOG_ORDER[$i];

		$year = $TB_LOG_YEAR[$n];
		$month = $TB_LOG_MONTH[$n];
		$day = $TB_LOG_DAY[$n];
		$titleno = $TB_LOG_TITLENO[$n];
		if ( $TB_LOG_FROM[$n] ne "COMMENT" ) {
			$s = sprintf( "<DIV class=\"tblline\"><A HREF=\"%s%04d%02dt.html#%02d%02dtb\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"tbtitle\">%s</SPAN>" .
			              "<SPAN class=\"tbfrom\">(%s)</SPAN></DIV>\n",
			              $TRACKBACKBASEURL, $year, $month, $day, $titleno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_TITLE[$n],
			              $TB_LOG_BLOGNAME[$n]
			);
			print FOUT "$s\n";
		} else {
			$cm = $TB_LOG_EXCERPT[$n];
			if ( $cm =~ s:^(([\x00-\x7f]|[\x80-\xff][\x80-\xff]){32}).*$:\1: ) {
				$cm .= "...";
			}
			$s = sprintf( "<DIV class=\"cmline\"><A HREF=\"%s%04d%02dt.html#%02d%02dcm\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"cmcomment\">%s</SPAN> " .
			              "<SPAN class=\"cmname\">(%s)</SPAN></DIV>\n",
			              $TRACKBACKBASEURL, $year, $month, $day, $titleno,
			              $TB_LOG_DATE[$n],
			              $cm,
			              $TB_LOG_TITLE[$n]
			);
			print FOUT "$s\n";
		}
		
	}
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = sprintf( $PUTDIR . $SLASH . 'tbcmlatest.html' );
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
	system( $cmd );
	umask( $umaskback );

}



1;
# [EOF]
